#INCLUDE "efrx_mere.h"
#INCLUDE "../prgs/main.h"

*******************************************************
PROCEDURE PDM_GetInterface(loInst,lcCollate) && Return instace of Plug-In
loInst=CREATEOBJECT("_EFRX_MERE",lcCollate)

****************************************************************
PROCEDURE PDM_GetGUI(loInterface,loPI,loSettings,lcLang) && Show form for settings
*@loInterface - Interface of plug-in
*@loPI        - Plug-in
*@loSettings  - Plug-in settings
* lcLang      - Language

LOCAL lcFile,lcClass
lcFile=ExtractShortFileFromFile(SUBST(SYS(16),AT(" ",SYS(16),2)+1))
lcClass="_EFRX_MERE_frm_"+lcLang

* Load localize VCX library
IF !lcLang=="en" AND ATC(lcFile+"_"+lcLang+".VCX",SET("CLASSLIB"))=0
   lcClass="_EFRX_MERE_frm_en"
ENDIF
loInterface=CREATEOBJECT(lcClass,@loPI,@loSettings)

****************************************************************************
DEFINE CLASS _EFRX_MERE AS _pdm_PlugIn && 
   Name="_EFRX_MERE"

   ID=103         && ID of Plug-in
   Type="EFRX" && 

   PROCEDURE GetCaption() && Return Caption of Plug-in
      RETURN This.GetString(PI_Caption)
   ENDPROC

   PROCEDURE GetDescription() && Return Description of Plug-in
      RETURN This.GetString(PI_Description)
   ENDPROC

   PROCEDURE Initialize() && Additive initialize
      * Load shared fxp modul for parsing texts (xhtml/code/see)
      LOCAL luCatch,lcPath,lcFile,lcClass,loPDMs,lcGUILang,llEn
      loPDMs=EVAL(This.PDMs)
      lcGUILang=loPDMs.GUICLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Load basic VCX library for GUI
      IF ATC(lcFile+".VCX",SET("CLASSLIB"))=0
         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+".vcx") ADDITIVE
         =loPDMs.SetCatch(luCatch) && Vra zachycen chyby
         IF loPDMs.nErr#0
            RETURN .F.
         ENDIF
      ENDIF

      * Load localize VCX library
      IF !lcGUILang=="en" AND ATC(lcFile+"_"+lcGUILang+".VCX",SET("CLASSLIB"))=0
         luCatch=poPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+"_"+lcGUILang+".vcx") ADDITIVE
         =poPDMs.SetCatch(luCatch) && Vra zachycen chyby
      ENDIF

      * Open table with localized strind for GUI
      llEn=.T.
      IF !lcGUILang=="en" AND ;
         loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\"+lcGUILang+".dbf",This.ALTAB,"NOUPDATE")=0
         SELE (This.ALTab)
         SET ORDER TO "I01"
         llEn=.F.
      ENDIF

      IF llEn
         CREATE CURSOR (This.ALTab) (XX000 I, XX001 M)
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Caption, "Mind's Eye Report Engine")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetCSS, "CSS File")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Description, [Plug-in pro zpracovn metadat ve sloupci COMMENT reportu/ttku pro konvertor Mind's Eye Report Engine.])

         SELE (This.ALTab)
         INDEX ON XX000 TAG I01
      ENDIF
   ENDPROC


   PROCEDURE Render(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      LOCAL loPDMs,loPDM,lii,liCount,lcHTML,lix,;
            llSingle,lcComment,lcRow,liz,lcURName,lcUROutline,lcUROutlineStyle,;
            lcURHREF,llExtract,liy,lix,lcURRotate, lcURIncludeFont,lcAHREF,lcPom,lcPom2,;
            lcURColor,lcURMask,lcURXLSF,llAnyExtract
      LOCAL ARRAY laData(17)

      loPDMs=EVAL(This.PDMs)
      loPDM=EVAL(This.PDM)
      
      STORE "" TO lcHTML,laData

      lcComment=loPar.Ram.COMMENT


*!*	      DFS Dynamic Font Style 
*!*	      DFC Dynamic Fill Color 
*!*	      DFP Dynamic Fill Pattern 
*!*	      DPC Dynamic Pen Color 
*!*	      DPP Dynamic Pen Pattern 
*!*	      DPS Dynamic Pen Size 
*!*	      DPL Dynamic Position Left 
*!*	      DPT Dynamic Position Top 
*!*	      DSH Dynamic Size Height 
*!*	      DSW Dynamic Size Width 

*:DFC:IIF(Amt<0,RGB(255,0,0),RGB(255,255,255))
      
      liCount=ALINES(laRows,lcComment)
      lcComment=""
      FOR lii=1 TO liCount
          lcRow=LTRIM(laRows(lii))

          liz=AT_NonSpace(@lcRow,1) && najdi prvn znak
          liz=IIF(liz=0,1,liz)

          llExtract=.F.
          DO CASE
             CASE UPPER(SUBST(lcRow,liz,6))=="*:DFS:"
                  IF LEN(laData(1))=0
                     laData(1)=SUBST(lcRow,liz+6)
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,6))=="*:DFC:"
                  IF LEN(laData(2))=0
                     laData(2)=SUBST(lcRow,liz+6)
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,6))=="*:DFP:"
                  IF LEN(laData(3))=0
                     laData(3)=SUBST(lcRow,liz+6)
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,6))=="*:DPC:"
                  IF LEN(laData(4))=0
                     laData(4)=SUBST(lcRow,liz+6)
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,6))=="*:DPP:"
                  IF LEN(laData(5))=0
                     laData(5)=SUBST(lcRow,liz+6)
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,6))=="*:DPS:"
                  IF LEN(laData(6))=0
                     laData(6)=SUBST(lcRow,liz+6)
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,6))=="*:DPL:"
                  IF LEN(laData(7))=0
                     laData(7)=SUBST(lcRow,liz+6)
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,6))=="*:DPT:"
                  IF LEN(laData(8))=0
                     laData(8)=SUBST(lcRow,liz+6)
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,6))=="*:DSH:"
                  IF LEN(laData(9))=0
                     laData(9)=SUBST(lcRow,liz+6)
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,6))=="*:DSW:"
                  IF LEN(laData(10))=0
                     laData(10)=SUBST(lcRow,liz+6)
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,6))=="*:DFN:"
                  IF LEN(laData(11))=0
                     laData(11)=SUBST(lcRow,liz+6)
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,6))=="*:DFA:"
                  IF LEN(laData(12))=0
                     laData(12)=SUBST(lcRow,liz+6)
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,6))=="*:DPA:"
                  IF LEN(laData(13))=0
                     laData(13)=SUBST(lcRow,liz+6)
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,6))=="*:DBC:"
                  IF LEN(laData(14))=0
                     laData(14)=SUBST(lcRow,liz+6)
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,6))=="*:DBS:"
                  IF LEN(laData(15))=0
                     laData(15)=SUBST(lcRow,liz+6)
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,12))=="*:HYPERLINK:"
                  IF LEN(laData(16))=0
                     laData(16)=SUBST(lcRow,liz+12)
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,11))=="*:PAPERBIN:"
                  IF LEN(laData(17))=0
                     laData(17)=SUBST(lcRow,liz+11)
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

          ENDCASE

          llAnyExtract=llAnyExtract OR llExtract
          IF !llExtract
             lcComment=lcComment+lcRow+CRLF
          ENDIF
      NEXT

      FOR lii=1 TO ALEN(laData)
          IF LEN(laData(lii))>0
             laData(lii)=m.loPDM.Expr2xhtml(laData(lii))
          ENDIF
      NEXT

      IF llAnyExtract
         lcHTML=lcHTML+;
                m.loPDM.aSpace(1)+[<table><tbody>]+m.loPDM.aSpace(21)
      ENDIF


      IF LEN(laData(1))>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_mere_td_bold">]+This.GetHTMLString(PI_HTML_DFS)+[</td><td>]+laData(1)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(laData(2))>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_mere_td_bold">]+This.GetHTMLString(PI_HTML_DFC)+[</td><td>]+laData(2)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(laData(3))>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_mere_td_bold">]+This.GetHTMLString(PI_HTML_DFP)+[</td><td>]+laData(3)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(laData(4))>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_mere_td_bold">]+This.GetHTMLString(PI_HTML_DPC)+[</td><td>]+laData(4)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(laData(5))>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_mere_td_bold">]+This.GetHTMLString(PI_HTML_DPP)+[</td><td>]+laData(5)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(laData(6))>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_mere_td_bold">]+This.GetHTMLString(PI_HTML_DPS)+[</td><td>]+laData(6)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(laData(7))>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_mere_td_bold">]+This.GetHTMLString(PI_HTML_DPL)+[</td><td>]+laData(7)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(laData(8))>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_mere_td_bold">]+This.GetHTMLString(PI_HTML_DPT)+[</td><td>]+laData(8)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(laData(9))>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_mere_td_bold">]+This.GetHTMLString(PI_HTML_DSH)+[</td><td>]+laData(9)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(laData(10))>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_mere_td_bold">]+This.GetHTMLString(PI_HTML_DSW)+[</td><td>]+laData(10)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(laData(11))>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_mere_td_bold">]+This.GetHTMLString(PI_HTML_DFN)+[</td><td>]+laData(11)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(laData(12))>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_mere_td_bold">]+This.GetHTMLString(PI_HTML_DFA)+[</td><td>]+laData(12)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(laData(13))>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_mere_td_bold">]+This.GetHTMLString(PI_HTML_DPA)+[</td><td>]+laData(13)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(laData(14))>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_mere_td_bold">]+This.GetHTMLString(PI_HTML_DBC)+[</td><td>]+laData(14)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(laData(15))>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_mere_td_bold">]+This.GetHTMLString(PI_HTML_DBS)+[</td><td>]+laData(15)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(laData(16))>0
         laData(16)=ALLT(laData(16))
         laData(16)=SUBST(laData(16),1,LEN(laData(16))-2)
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_mere_td_bold">]+This.GetHTMLString(PI_HTML_Hyperlink)+[</td><td><a href="]+laData(16)+[">]+laData(16)+"</a></td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(laData(17))>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_mere_td_bold">]+This.GetHTMLString(PI_HTML_PaperBin)+[</td><td>]+laData(17)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF llAnyExtract
         lcHTML=lcHTML+;
                m.loPDM.aSpace(1)+[</tbody></table>]+m.loPDM.aSpace(21)
      ENDIF


      IF LEN(lcHTML)>0
         lcHTML=m.loPDM.aSpace(1)+"<hr>"+m.loPDM.aSpace(21)+lcHTML
      ENDIF

      loPar.Ram.COMMENT=lcComment

      RETURN lcHTML
   ENDPROC

   PROCEDURE GetSetting()
      RETURN CREATEOBJECT("_EFRX_MERE_par")
   ENDPROC

   * Nate nastaven
   PROCEDURE Open(lcFile,loSettings)
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      loSettings.CSS=GetINIString(lcSection,"CSS",loSettings.CSS,254,@lcFile)
      loSettings.JS=GetINIString(lcSection,"JS",loSettings.JS,254,@lcFile)

      RETURN _PDM_OK
   ENDPROC

   * Ulo nastaven
   PROCEDURE Save(lcFile,loSettings)
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      =WriteINIString(lcSection,"CSS",ALLT(loSettings.CSS),@lcFile)
      =WriteINIString(lcSection,"JS",ALLT(loSettings.JS),@lcFile)
      RETURN _PDM_OK
   ENDPROC


   PROCEDURE Clone(loSrc,loDst)
      * loSrc - Source object
      * loDst - Destination object
      loDst.CSS=loSrc.CSS
      loDst.JS=loSrc.JS
   ENDPROC

   PROCEDURE OpenSources(loSetting) && Open other source
      * loSetting - Object of settings
      LOCAL loPDMs,lcLang,lcPath,lcFile,llEn
      loPDMs=EVAL(This.PDMs)
      lcLang=loPDMs.HTMLCLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Open table with HTML's string
      IF !USED(This.AHTML)
         llEn=.T.
         IF !lcLang=="en" AND ;
            loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\HTML_"+lcLang+".dbf",This.AHTML,"NOUPDATE")=0
            SELE (This.AHTML)
            SET ORDER TO "I01"
            llEn=.F.
         ENDIF

         IF llEn
            CREATE CURSOR (This.AHTML) (XX000 I, XX001 M)

            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_DFS, "Dynamic Font Style:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_DFC, "Dynamic Fill Color:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_DFP, "Dynamic Fill Pattern:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_DPC, "Dynamic Pen Color:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_DPP, "Dynamic Pen Pattern:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_DPS, "Dynamic Pen Size:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_DPL, "Dynamic Position Left:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_DPT, "Dynamic Position Top:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_DSH, "Dynamic Size Height:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_DSW, "Dynamic Size Width:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_DFN, "Dynamic Font Name:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_DFA, "Dynamic Fill Alpha Level:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_DPA, "Dynamic Pen Alpha Level:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_DBC, "Dynamic Back Color:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_DBS, "Dynamic Back Style:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Hyperlink, "Hyperlink:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_PaperBin, "PaperBin:")

            SELE (This.AHTML)
            INDEX ON XX000 TAG I01
         ENDIF
      ENDIF
      RETURN .T.
   ENDPROC

   PROCEDURE CloseSources()
      RETURN .T.
   ENDPROC

ENDDEFINE

***********************************************************
DEFINE CLASS _EFRX_MERE_par AS _pdm_PlugIn_Parameter
   Name="_EFRX_MERE_par"
   DIME aCSS(1),aJS(1)
   OK=.F.
 
   CSS="efrx_mere.css" && Relative to efrx_MERE.fxp
   JS="" && 

   _CSS="" && Relative to ....
   _JS="" && 

ENDDEFINE
